;--------------------------------------------------
;
;  GPS controlled clock
;
; program name: GPSCLOCK3.ASM
;
; Version:      1.01
;
; date:    2012/8/28
;
; programer: M.Nomura 
;
; copyright(c) JJ1SUN
;
;-------------------------------------------------
; version up note
;
; V.1.01   8MHz OSC@
;
; V.1.00  [XEo[W
;
; V.0.01  vg^Cv
;
;-------------------------------------------------
; GPS reciever type
;
; CanMore GT-723F (MNEA-0183 model) 
; Hdqōw
;
;-------------------------------------------------
; LCD display type
;
; 16 char. 1 line display 
;
;-------------------------------------------------
; PIC16F688 & 8.0MHz internal osc      
;
	LIST	P=16F688
        INCLUDE	"P16F688.INC"
 
	__CONFIG   _FCMEN_OFF & _IESO_OFF & _CP_OFF & _CPD_OFF & _BOD_ON & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_CLKOUT 


;------------------------------
; ϐ錾
;
; work register
;
CNT1	EQU	H'20'
CNT2	EQU	H'21'
CNT3	EQU	H'22'
TEMP1	EQU	H'23'			; [NP
TEMP2	EQU	H'24'			; [NQ
B_HOUR10	EQU	H'25'		; (10̌j
B_MINI10	EQU	H'26'		; (10̌j
B_SEC10		EQU	H'27'		; b(10̌j
B_HOUR	EQU	H'28'			; 
B_MINI	EQU	H'29'			; 
B_SEC	EQU	H'2A'			; b
B_SAT10	EQU	H'31'			; q(10̌j
B_SAT	EQU	H'2B'			; q
TEMP3	EQU	H'2C'
TEMP4	EQU	H'2D'	
DISPDATA	EQU	H'2E'		; \pobt@
LSD	EQU	H'2F'
MSD	EQU	H'30'
;
; |[g̎w
;
	
#DEFINE	LCD_RS	PORTA, 0   ;RSM
#DEFINE	LCD_E	PORTA, 1   ;EM
#DEFINE	LCD_DB	PORTC      ;DB(ʂSrbgj
#DEFINE	DISPMODE PORTA,3	; UTC / JST@؂ւ
; 				
;----------------------------------
	ORG	0		; Reset Start

;-----------------------------------
; C[`
;
MAIN
	GOTO	START
;
;  I/O|[g
;
START
	CLRF	STATUS
	BSF	STATUS,RP0	; Bank 1 I
	MOVLW	B'01111001'	; 8MHNbNgp
	MOVWF	OSCCON				

	BCF	STATUS,RP0	; Bank 0 I
	CLRF	PORTA		; init PortA
	
	MOVLW	B'00000111'	; Rp[^gpȂ
	MOVWF	CMCON0
	
	BSF	STATUS,RP0	; Bank 1@I

	MOVLW	B'00111000'	; RA0,RA1,RA2 o,RA3 
	MOVWF	TRISA

	MOVLW	B'00000000'	; RA0 - RA3 digital I/O
	MOVWF	ANSEL		; 

	MOVLW	B'00000000'	; RC0,RC1,RC2,RC3 output
	MOVWF	TRISC

	MOVLW	B'00010000'	; Fosc/8
	MOVWF	ADCON1

	BCF	STATUS,RP0	; bank 0@ɖ߂

	MOVLW	B'00000001'	; Left justified
	MOVWF	ADCON0
	
	BCF	INTCON,PEIE	; ӊ荞OFF

	CLRF	PORTA		; Clear I/O Port
	CLRF	PORTC

	CALL	UARTINIT	; UART CjVCY
	CALL	LCD_INI		; LCD CjVCY

	CALL	DISPID		; program ID
	CALL	TIME_WAIT_100	; Pbԑ҂
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100
	CALL	TIME_WAIT_100

	CALL	LCD_CLR		; \NA
	MOVLW	"0"
	MOVWF	B_SAT10
	MOVWF	B_SAT

LOOP1
	CALL	GETTIME		; get time data from GPS
	btfsc	DISPMODE
	GOTO	LOOP2
	CALL	DISPTIMEJ	; ѕߑq\(JST)
	GOTO	LOOP1	
;
LOOP2
	CALL	DISPTIMEU	; ѕߑq\(UTC)
	GOTO	LOOP1
;
;---------------------------------------------
; f[^GPSM@擾
; GPSM@Ɉˑ郋[`
; (GT-723F NMEA-0183 formatp)
;
@
GETTIME
	CALL	UARTREC		; 1ǂݍ
	SUBLW	"$"		; header (GPSM@ˑj
	BTFSS	STATUS,Z
	GOTO	GETTIME

	CALL	UARTREC
	SUBLW	"G"
	BTFSS	STATUS,Z
	GOTO	GETTIME

	CALL	UARTREC
	SUBLW	"P"
	BTFSS	STATUS,Z
	GOTO	GETTIME

	CALL	UARTREC
	SUBLW	"G"
	BTFSS	STATUS,Z
	GOTO	GETTIME

	CALL	UARTREC
	SUBLW	"G"
	BTFSS	STATUS,Z
	GOTO	GETTIME

	CALL	UARTREC
	SUBLW	"A"
	BTFSS	STATUS,Z
	GOTO	GETTIME
;
	CALL	UARTREC		; ","
;
	CALL	UARTREC
	MOVWF	B_HOUR10
	CALL	UARTREC
	MOVWF	B_HOUR
;
	CALL	UARTREC
	MOVWF	B_MINI10
	CALL	UARTREC
	MOVWF	B_MINI
;
	CALL	UARTREC
	MOVWF	B_SEC10
	CALL	UARTREC
	MOVWF	B_SEC
;
	MOVLW	6		; 6 ړǂݔ΂
	MOVWF	CNT1
GETTIME2
	CALL	SKIPTOC
	DECFSZ	CNT1,F
	GOTO	GETTIME2
;
	CALL	UARTREC
	MOVWF	B_SAT10
	CALL	UARTREC
	MOVWF	B_SAT

	RETURN
;
;---------------------------------------------
; SKIP to Comma
;
SKIPTOC
	CALL	UARTREC
	SUBLW	","
	BTFSS	STATUS,Z
	GOTO	SKIPTOC
	RETURN
;
;----------------------------------------------
; time display@(UTC mode)
;
DISPTIMEU
	movlw	B'10000000'	;1 line 0 column
	call	LCD_CMD

	movf	B_HOUR10,w
	call	LCD_DATA
	movf	B_HOUR,w
	call	LCD_DATA
	movlw	":"
	call	LCD_DATA

	movf	B_MINI10,w
	call	LCD_DATA
	movf	B_MINI,w
	call	LCD_DATA
	movlw	":"
	call	LCD_DATA

	movf	B_SEC10,w
	call	LCD_DATA
	movf	B_SEC,w
	call	LCD_DATA

	movlw	B'11000000'	;2 line 0 column (1 line 8 column)
	call	LCD_CMD

	movlw	" "
	call	LCD_DATA
	movlw	"U"
	call	LCD_DATA
	movlw	"T"
	call	LCD_DATA
	movlw	"C"
	call	LCD_DATA
	movlw	" "

	call	LCD_DATA
	movlw	"S"
	call	LCD_DATA
	movf	B_SAT10,w
	call	LCD_DATA
	movf	B_SAT,w
	call	LCD_DATA
		
	return
;	
;----------------------------------------------
; time display (JST mode)
;
DISPTIMEJ
	call	JST_SHIFT

	movlw	B'10000000'	;1 line 0 column
	call	LCD_CMD

	movf	B_HOUR10,w
	call	LCD_DATA
	movf	B_HOUR,w
	call	LCD_DATA
	movlw	":"
	call	LCD_DATA

	movf	B_MINI10,w
	call	LCD_DATA
	movf	B_MINI,w
	call	LCD_DATA
	movlw	":"
	call	LCD_DATA

	movf	B_SEC10,w
	call	LCD_DATA
	movf	B_SEC,w
	call	LCD_DATA

	movlw	B'11000000'	;2 line 0 column (1 line 8 column)
	call	LCD_CMD

	movlw	" "
	call	LCD_DATA
	movlw	"J"
	call	LCD_DATA
	movlw	"S"
	call	LCD_DATA
	movlw	"T"
	call	LCD_DATA
	movlw	" "

	call	LCD_DATA
	movlw	"S"
	call	LCD_DATA
	movf	B_SAT10,w
	call	LCD_DATA
	movf	B_SAT,w
	call	LCD_DATA
		
	return
;
;----------------------------------------------
; 9ԃVtg
;
JST_SHIFT
	movf	B_HOUR10,w
	sublw	"1"
	btfsc	STATUS,C
	goto	JST_SHIFT2
	movlw	"0"
	movwf	B_HOUR10
	movf	B_HOUR,w
	addlw	D'5'
	movwf	B_HOUR
	return

JST_SHIFT2
	movf	B_HOUR10,w
	sublw	"0"
	btfsc	STATUS,C
	goto	JST_SHIFT3
	movf	B_HOUR,w
	sublw	"4"
	btfsc	STATUS,C
	goto	JST_SHIFT4
	movlw	"0"
	movwf	B_HOUR10
	movlw	D'5'
	subwf	B_HOUR,F
	return

JST_SHIFT4
	movf	B_HOUR,w
	sublw	"0"
	btfsc	STATUS,Z
	goto 	JST_SHIFT5
	movlw	"2"
	movwf	B_HOUR10
	decfsz	B_HOUR,F
	nop
	return

JST_SHIFT3
	movf	B_HOUR,w
	sublw	"0"
	btfsc	STATUS,Z
	goto	JST_SHIFT5
	movlw	"1"
	movwf	B_HOUR10
	decfsz	B_HOUR,F
	nop
	return

JST_SHIFT5
	movf	B_HOUR,w
	addlw	D'9'
	movwf	B_HOUR
	return
;
;----------------------------------------------
; Program ID display
;
DISPID
	movlw	B'10000000'	;1 line 0 column
	call	LCD_CMD
	
	movlw	"G"		; display"GPS clock v 1.XX"
	call	LCD_DATA
	movlw	"P"
	call	LCD_DATA
	movlw	"S"
	call	LCD_DATA
	movlw	" "
	call	LCD_DATA
	movlw	"c"
	call	LCD_DATA
	movlw	"l"
	call	LCD_DATA
	movlw	"o"
	call	LCD_DATA
	movlw	"c"
	call	LCD_DATA

	movlw	B'11000000'	;2 line 0 column (1 line 8 column)
	call	LCD_CMD

	movlw	"k"
	call	LCD_DATA
	movlw	"3"
	call	LCD_DATA
	movlw	" "
	call	LCD_DATA
	movlw	" "
	call	LCD_DATA
	movlw	"1"		; Must be change version no.
	call	LCD_DATA
	movlw	"."
	call	LCD_DATA
	movlw	"0"		
	call	LCD_DATA
	movlw	"1"
	call	LCD_DATA
	return
;
;------------------------------------------
; Display 1 packed BCD data (2 digits)
;
DISP_D
	movwf	TEMP3		;save
	movf	TEMP3,W		;get 1,2digit
	swapf	TEMP3,W		;upper digit
	andlw	H'0F'		;
	iorlw	H'30'		;convert to ASCII
	call	LCD_DATA
	movf	TEMP3,W		;
	andlw	H'0F'		;lower digit
	iorlw	H'30'		;convert to ASCII
	call	LCD_DATA
	return
;
;--------------------------------------------
; Binary to 2 digit BCD conversion
;
BIN2BCD
	clrf    MSD
	movwf   LSD
BIN2BCD1
	movlw   D'10'
	subwf   LSD,W
	BTFSS   STATUS,C
	goto    BIN2BCD2
	movwf   LSD
	incf    MSD, F
	goto	BIN2BCD1

BIN2BCD2
	swapf	MSD,f
	movf	LSD,W
	iorwf	MSD,W
	return
;
;--------------------------------------------
; LCD
;
LCD_INI
	call	TIME_WAIT_010	;20ms wait
	call	TIME_WAIT_010

	movlw	H'03'		;8 bit mode
	call	PUTCMD
	call	TIME_WAIT_010	;10msec wait
	movlw	H'03'		;8 bit mode
	call	PUTCMD
	call	TIME_WAIT_010
	movlw	H'03'		;8 bit mode
	call	PUTCMD
	call	TIME_WAIT_010

	movlw	H'02'		;4 bit mode
	call	PUTCMD
	call	TIME_WAIT_010
				;4rbg[hŋ@\ڍאݒ	
	movlw	H'2E'		;Function DL=0 N=F=1
	call	LCD_CMD
	movlw	H'08'		;\It D=C=B=0
	call	LCD_CMD
	movlw	H'0C'		;\I D=1 C=0 B=1
	call	LCD_CMD
	movlw	H'06'		;Entry I/D=1 S=0
	call	LCD_CMD
	call	LCD_CLR
	return	
;
;-----------------------------------------
; t\֕\f[^o
;
LCD_DATA
	movwf	DISPDATA	;f[^ꎞۑ
	swapf	DISPDATA,W	;f[^ʑo
	call	PUTDATA		;E

	movf	DISPDATA,W	;f[^ʑo
	call	PUTDATA		;E
	call	TIME_WAIT_100U	;s҂
	return	
;
;-------------------------------------------
; t\֐R}ho
;
LCD_CMD
	movwf	DISPDATA	;f[^ꎞۑ
	swapf	DISPDATA,W	;f[^ʑo
	call	PUTCMD		;E
	movf	DISPDATA,W	;f[^ʑo
	call	PUTCMD		;E
	call	TIME_WAIT_100U	;s҂
	return	
;	
;-------------------------------------------
; t\̑S
;
LCD_CLR
	movlw	H'01'		;Clear Display command
	call	LCD_CMD
	call	TIME_WAIT_010	;ǉ10msfBC
	return	
;
;-------------------------------------------
; \J[\z[|WVɈړ
;
LCD_HOME
	movlw	H'02'		;Cursor at Home
	call	LCD_CMD
	call	TIME_WAIT_010
	return
;
;--------------------------------------------
; M̏o
;
PUTDATA
	andlw	H'0F'		;Wreg4rbg̓f[^
	movwf	LCD_DB
	bsf	LCD_RS		;RSM=1
	goto	PUTSIG
PUTCMD
	andlw	H'0F'		;RSM=0
	movwf	LCD_DB
	bcf	LCD_RS		;RSM=1
PUTSIG
	bsf	LCD_E		;EM=1
	nop
	bcf	LCD_E		;EM=0
	return
;
;-------------------------------------
; 1M[`
;
; exit: W-reg get char.
;
UARTREC
	BTFSS	PIR1,RCIF	; Mobt@tH
	GOTO	UARTREC
	BTFSC	RCSTA,FERR	; t[~OG[?
	GOTO	UARTREC1
	BTFSC	RCSTA,OERR	; I[oG[H
	GOTO	UARTREC2

	MOVF	RCREG,W
	RETURN

UARTREC1
	MOVF	RCREG,W		; t[~OG[NA
	BTFSS	RCSTA,OERR	; I[o[G[H
	GOTO	UARTREC

UARTREC2
	BCF	RCSTA,CREN	; I[o[G[NA
	BSF	RCSTA,CREN
	GOTO	UARTREC
;
;-------------------------------------
; 1M[`
;
; entry: W-reg char for send
;
UARTTRN
	BTFSS	TXSTA,TRMT	; Mobt@tH
	GOTO	UARTTRN
	MOVWF	TXREG
	RETURN
;
;-------------------------------------
; VA|[g[`
;
; entry: nonde
;
UARTINIT
	MOVLW	B'00100000'	; async,8bit,TX enable,low speed
	MOVWF	TXSTA
	MOVLW	B'10010000'	; RX enable
	MOVWF	RCSTA
	MOVLW	B'00001000'	; 16bit baud counter
	MOVWF	BAUDCTL
	MOVLW	D'52'		; 52=9600bps @8.0MHz
	MOVWF	SPBRG
	MOVLW	H'00'
	MOVWF	SPBRGH
	RETURN
;
;-------------------------------------
; 100msec EGCg[`
;
; entry: none
;
TIME_WAIT_100
	MOVLW	H'C8'		; CNT2 = 200
	MOVWF	CNT2

TIMLP1001
	MOVLW	H'FA'		; CNT1 = 187
	MOVWF	CNT1

TIMLP1002			; 2s~2500.5msec @8.0MHz
	NOP
	DECFSZ	CNT1,F
	GOTO	TIMLP1002

	DECFSZ	CNT2,F		; 0.5msec~200100msec
	GOTO	TIMLP1001

	RETURN

;
;-----------------------------------------
; 10msec EGCg[`
;
; entry: none
;
TIME_WAIT_010
	MOVLW	H'14'		; CNT2 = 20
	MOVWF	CNT2

TIMLP0101
	MOVLW	H'FA'		; CNT1 = 250
	MOVWF	CNT1

TIMLP0102			; 2s~2500.5msec
	NOP
	DECFSZ	CNT1,F
	GOTO	TIMLP0102

	DECFSZ	CNT2,F		; 0.5msec~2010msec
	GOTO	TIMLP0101

	RETURN
;
;--------------------------------------------
; 1msec EGCg[`
;
; entry: none
;
TIME_WAIT_001
	MOVLW	H'FA'		; CNT1 = 250
	MOVWF	CNT1
TIMLP0011			; 2s~2500.5msec
	NOP
	DECFSZ	CNT1,F
	GOTO	TIMLP0011

	MOVLW	H'FA'
	MOVWF	CNT1
TIMLP0012
	NOP
	DECFSZ	CNT1,F
	GOTO	TIMLP0012

	RETURN
;
;----------------------------------------------
; 100s@EGCg[`
;
; entry: none
;
TIME_WAIT_100U
	MOVLW	H'32'		; 2s x 50 = 100s
	MOVWF	CNT1
TIMLP100U1
	NOP
	DECFSZ	CNT1,F
	GOTO	TIMLP100U1

	RETURN
;
;----------------------------------------------
;
	NOP
;
	END


